%include %{_rpmconfigdir}/macros.python2

Name: yum-utils
Version: 1.1.31
Release: 9
License: GPL-2.0-or-later
Summary: Utilities for the yum package manager
URL: http://yum.baseurl.org/download/yum-utils

BuildArch: noarch

Source0: http://yum.baseurl.org/download/yum-utils/%{name}-%{version}.tar.gz

Patch0: yum-utils-pase.patch
Patch1: yum-utils-ibmi-privileges.patch

BuildRequires: python2
BuildRequires: gettext-runtime

Requires: python2-iniparse
Requires: yum


%description
yum-utils is a collection of utilities and examples for the yum package
manager. It includes utilities by different authors that make yum easier and
more powerful to use.

# %package -n yum-updateonboot
# Summary: Run yum update on system boot
# Requires: python, yum
# Requires(pre): chkconfig
# Requires(post): chkconfig
# 
# %description -n yum-updateonboot
# Runs yum update on system boot. This allows machines that have been turned
# off for an extended amount of time to become secure immediately, instead of
# waiting until the next early morning cron job.

%package -n yum-plugin-changelog
Summary: Yum plugin for viewing package changelogs before/after updating
# changelog requires new update_md.UpdateMetadata() API in 3.2.23
Requires: yum
Requires: python2-dateutil

%description -n yum-plugin-changelog
This plugin adds a command line option to allow viewing package changelog
deltas before or after updating packages.

%package -n yum-plugin-fastestmirror
Summary: Yum plugin which chooses fastest repository from a mirrorlist
Requires: yum

%description -n yum-plugin-fastestmirror
This plugin sorts each repository's mirrorlist by connection speed
prior to downloading packages.

%package -n yum-plugin-protectbase
Summary: Yum plugin to protect packages from certain repositories.
Requires: yum

%description -n yum-plugin-protectbase
This plugin allows certain repositories to be protected. Packages in the
protected repositories can't be overridden by packages in non-protected
repositories even if the non-protected repo has a later version.

%package -n yum-plugin-versionlock
Summary: Yum plugin to lock specified packages from being updated
Requires: yum

%description -n yum-plugin-versionlock
This plugin takes a set of name/versions for packages and excludes all other
versions of those packages (including optionally following obsoletes). This
allows you to protect packages from being updated by newer versions,
for example.

%package -n yum-plugin-tsflags
Summary: Yum plugin to add tsflags by a commandline option
Requires: yum

%description -n yum-plugin-tsflags
This plugin allows you to specify optional transaction flags on the yum
command line

%package -n yum-plugin-downloadonly
Summary: Yum plugin to add downloadonly command option
Requires: yum

%description -n yum-plugin-downloadonly
This plugin adds a --downloadonly flag to yum so that yum will only download
the packages and not install/update them.

%package -n yum-plugin-priorities
Summary: plugin to give priorities to packages from different repos
Requires: yum

%description -n yum-plugin-priorities
This plugin allows repositories to have different priorities.
Packages in a repository with a lower priority can't be overridden by packages
from a repository with a higher priority even if repo has a later version.

# %package -n yum-plugin-refresh-updatesd
# Summary: Tell yum-updatesd to check for updates when yum exits
# Requires: yum
# Requires: yum-updatesd
# 
# %description -n yum-plugin-refresh-updatesd
# yum-refresh-updatesd tells yum-updatesd to check for updates when yum exits.
# This way, if you run 'yum update' and install all available updates, puplet
# will almost instantly update itself to reflect this.

%package -n yum-plugin-merge-conf
Summary: Yum plugin to merge configuration changes when installing packages
Requires: yum

%description -n yum-plugin-merge-conf
This yum plugin adds the "--merge-conf" command line option. With this option,
Yum will ask you what to do with config files which have changed on updating a
package.

%package -n yum-plugin-security
Summary: Yum plugin to enable security filters
Requires: yum

%description -n yum-plugin-security
This plugin adds the options --security, --cve, --bz and --advisory flags
to yum and the list-security and info-security commands.
The options make it possible to limit list/upgrade of packages to specific
security relevant ones. The commands give you the security information.

%package -n yum-plugin-upgrade-helper
Summary: Yum plugin to help upgrades to the next distribution version
Requires: yum

%description -n yum-plugin-upgrade-helper
this plugin allows yum to erase specific packages on install/update based on an additional
metadata file in repositories. It is used to simplify distribution upgrade hangups.

# %package -n yum-plugin-aliases
# Summary: Yum plugin to enable aliases filters
# # Requires args_hook
# Requires: yum
# Requires: yum-utils-translations = %{version}-%{release}
# 
# %description -n yum-plugin-aliases
# This plugin adds the command alias, and parses the aliases config. file to
# enable aliases.

%package -n yum-plugin-list-data
Summary: Yum plugin to list aggregate package data
Requires: yum

%description -n yum-plugin-list-data
This plugin adds the commands list- vendors, groups, packagers, licenses,
arches, committers, buildhosts, baseurls, package-sizes, archive-sizes and
installed-sizes.

%package -n yum-plugin-filter-data
Summary: Yum plugin to list filter based on package data
Requires: yum

%description -n yum-plugin-filter-data
This plugin adds the options --filter- vendors, groups, packagers, licenses,
arches, committers, buildhosts, baseurls, package-sizes, archive-sizes and
installed-sizes. Note that each package must match at least one pattern/range in
each category, if any were specified.

%package -n yum-plugin-tmprepo
Summary: Yum plugin to add temporary repositories
Requires: yum
Requires: createrepo

%description -n yum-plugin-tmprepo
This plugin adds the option --tmprepo which takes a url to a .repo file
downloads it and enables it for a single run. This plugin tries to ensure
that temporary repositories are safe to use, by default, by not allowing
gpg checking to be disabled.

%package -n yum-plugin-verify
Summary: Yum plugin to add verify command, and options
Requires: yum

%description -n yum-plugin-verify
This plugin adds the commands verify, verify-all and verify-rpm. There are
also a couple of options. This command works like rpm -V, to verify your
installation.

%package -n yum-plugin-keys
Summary: Yum plugin to deal with signing keys
Requires: yum

%description -n yum-plugin-keys
This plugin adds the commands keys, keys-info, keys-data and keys-remove. They
allow you to query and remove signing keys.

%package -n yum-plugin-remove-with-leaves
Summary: Yum plugin to remove dependencies which are no longer used because of a removal
Requires: yum

%description -n yum-plugin-remove-with-leaves
This plugin removes any unused dependencies that were brought in by an install
but would not normally be removed. It helps to keep a system clean of unused
libraries and packages.

%package -n yum-plugin-post-transaction-actions
Summary: Yum plugin to run arbitrary commands when certain pkgs are acted on
Requires: yum

%description -n yum-plugin-post-transaction-actions
This plugin allows the user to run arbitrary actions immediately following a
transaction when specified packages are changed.

# %package -n yum-NetworkManager-dispatcher
# Summary: NetworkManager script which tells yum to check it's cache on network change
# Requires: yum
# 
# %description -n yum-NetworkManager-dispatcher
# This NetworkManager "dispatch script" forces yum to check its cache if/when a
# new network connection happens in NetworkManager. Note that currently there is
# no checking of previous data, so if your WiFi keeps going up and down (or you
# suspend/resume a lot) yum will recheck its cached data a lot.

%package -n yum-plugin-rpm-warm-cache
Summary: Yum plugin to access the rpmdb files early to warm up access to the db 
Requires: yum

%description -n yum-plugin-rpm-warm-cache
This plugin reads the rpmdb files into the system cache before accessing the
rpmdb directly. In some cases this should speed up access to rpmdb information

# %package -n yum-plugin-auto-update-debug-info
# # Works by searching for *-debuginfo ... so it shouldn't trigger on itself.
# Summary: Yum plugin to enable automatic updates to installed debuginfo packages
# Requires: yum
# 
# %description -n yum-plugin-auto-update-debug-info
# This plugin looks to see if any debuginfo packages are installed, and if there
# are it enables all debuginfo repositories that are "children" of enabled
# repositories.

%package -n yum-plugin-show-leaves
Summary: Yum plugin which shows newly installed leaf packages
Requires: yum

%description -n yum-plugin-show-leaves
Yum plugin which shows newly installed leaf packages
and packages that became leaves after a transaction

%package -n yum-plugin-local
Summary: Yum plugin to automatically manage a local repo. of downloaded packages
# Who the hell knows what version :)
Requires: yum
Requires: createrepo

%description -n yum-plugin-local
When this plugin is installed it will automatically copy all downloaded packages
to a repository on the local filesystem, and (re)build that repository. This
means that anything you've downloaded will always exist, even if the original
repo. removes it (and can thus. be reinstalled/downgraded/etc.).

# %package -n yum-plugin-fs-snapshot
# Summary: Yum plugin to automatically snapshot your filesystems during updates
# Requires: yum
# 
# %description -n yum-plugin-fs-snapshot
# When this plugin is installed it will automatically snapshot any
# filesystem that is touched by the packages in a yum update or yum remove.

%package -n yum-plugin-ps
Summary: Yum plugin to look at processes, with respect to packages
Requires: yum

%description -n yum-plugin-ps
When this plugin is installed it adds the yum command "ps", which allows you
to see which running processes are accociated with which packages (and if they
need rebooting, or have updates, etc.)
# 
# %package -n yum-plugin-puppetverify
# Summary: Yum plugin to add puppet checksums to verify data
# Requires: yum
# Requires: PyYAML >= 3.09
# Requires: puppet
# 
# %description -n yum-plugin-puppetverify
# Supplies checksums for files in packages from puppet's state file. 

%prep
%setup -q

%patch0 -p1
%patch1 -p1

%install
find . -type f | xargs perl -p -i -e 's|/usr/bin/python|%{_bindir}/python2|g; s|/usr/bin|%{_bindir}|g; s|/usr/sbin|%{_bindir}|g; s|/usr/share/man|%{_mandir}|g; s|/usr/share|%{_datadir}|g; s|/etc|%{_sysconfdir}/yum|g;  s|/var|%{_localstatedir}|g;' 

make SUBDIRS='docs yumutils' PYTHON=python2 DESTDIR=%{buildroot} install
# make -C updateonboot DESTDIR=%{buildroot} install

# Plugins to install
plugins="\
 changelog \
 fastestmirror \
 protectbase \
 versionlock \
 tsflags \
 downloadonly \
 priorities \
 merge-conf \
 security \
 upgrade-helper \
 list-data \
 filter-data \
 tmprepo \
 verify \
 keys \
 remove-with-leaves \
 post-transaction-actions \
 rpm-warm-cache \
 show-leaves \
 local \
 ps \
"

mkdir -p %{buildroot}/%{_sysconfdir}/yum/pluginconf.d/ %{buildroot}%{_datadir}/yum-plugins/
mkdir -p %{buildroot}/%{_sysconfdir}/yum/post-actions

cd plugins
for plug in $plugins
do
    install -m 644 $plug/*.conf %{buildroot}/%{_sysconfdir}/yum/pluginconf.d/
    install -m 644 $plug/*.py %{buildroot}%{_datadir}/yum-plugins/
#     %{__python} -c "import compileall; compileall.compile_dir('%{buildroot}%{_datadir}/yum-plugins', 1)"
done

# install -m 644 aliases/aliases %{buildroot}/%{_sysconfdir}/yum/aliases.conf
install -m 644 versionlock/versionlock.list %{buildroot}/%{_sysconfdir}/yum/pluginconf.d/

# need for for the ghost in files section of yum-plugin-local
# mkdir -p %{buildroot}/%{_sysconfdir}/yum.repos.d
# touch %{buildroot}%{_sysconfdir}/yum.repos.d/_local.repo

rm -r %{buildroot}%{_sysconfdir}/yum/NetworkManager
rm -r %{buildroot}%{_sysconfdir}/yum/bash_completion.d

rm %{buildroot}%{_mandir}/man1/yum-aliases.1
rm %{buildroot}%{_mandir}/man1/yum-fs-snapshot.1
rm %{buildroot}%{_mandir}/man5/yum-fs-snapshot.conf.5

# %post -n yum-updateonboot
# /sbin/chkconfig --add yum-updateonboot >/dev/null 2>&1 || :;
# 
# %preun -n yum-updateonboot
# if [ $1 = 0 ]; then
#     /sbin/service yum-updateonboot stop >/dev/null 2>&1 || :;
#     /sbin/chkconfig --del yum-updateonboot >/dev/null 2>&1 || :;
# fi

# create symlinks for previously shipped sbin/ files now in bin/
mkdir -p %{buildroot}%{_prefix}/sbin
ln -s %{_bindir}/yum-complete-transaction %{buildroot}%{_prefix}/sbin/yum-complete-transaction
ln -s %{_bindir}/yumdb %{buildroot}%{_prefix}/sbin/yumdb


%files
%defattr(-, qsys, *none)

%doc README yum-util-cli-template
%doc COPYING
# %doc plugins/README

%{py_sitedir}/yumutils/

# %{_sysconfdir}/bash_completion.d

%{_prefix}/sbin/yum-complete-transaction
%{_prefix}/sbin/yumdb

%{_bindir}/debuginfo-install
%{_bindir}/find-repos-of-install
%{_bindir}/needs-restarting
%{_bindir}/package-cleanup
%{_bindir}/repoclosure
%{_bindir}/repodiff
%{_bindir}/repomanage
%{_bindir}/repoquery
%{_bindir}/repotrack
%{_bindir}/reposync
%{_bindir}/repo-graph
%{_bindir}/repo-rss
%{_bindir}/verifytree
%{_bindir}/yumdownloader
%{_bindir}/yum-builddep
%{_bindir}/yum-config-manager
%{_bindir}/yum-debug-dump
%{_bindir}/yum-groups-manager
%{_bindir}/yum-debug-restore
%{_bindir}/show-installed
%{_bindir}/show-changed-rco
%{_bindir}/yum-complete-transaction
%{_bindir}/yumdb

%{_mandir}/man1/yum-utils.1*
%{_mandir}/man1/debuginfo-install.1*
%{_mandir}/man1/package-cleanup.1*
%{_mandir}/man1/repo-rss.1*
%{_mandir}/man1/repoquery.1*
%{_mandir}/man1/repodiff.1*
%{_mandir}/man1/reposync.1*
%{_mandir}/man1/show-changed-rco.1*
%{_mandir}/man1/show-installed.1*
%{_mandir}/man1/yum-builddep.1*
%{_mandir}/man1/yum-debug-dump.1*
%{_mandir}/man8/yum-complete-transaction.8*
%{_mandir}/man1/yum-groups-manager.1*
%{_mandir}/man8/yumdb.8*
%{_mandir}/man1/yumdownloader.1*

# %files -n yum-updateonboot
# %defattr(-, qsys, *none)
# %doc updateonboot/README COPYING
# %config(noreplace) %{_sysconfdir}/sysconfig/yum-updateonboot
# %{_initrddir}/yum-updateonboot

%files -n yum-plugin-changelog
%defattr(-, qsys, *none)
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/changelog.conf
%doc COPYING
%{_datadir}/yum-plugins/changelog.*
%{_mandir}/man1/yum-changelog.1*
%{_mandir}/man5/yum-changelog.conf.5*

%files -n yum-plugin-fastestmirror
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/fastestmirror.conf
%{_datadir}/yum-plugins/fastestmirror*.*

%files -n yum-plugin-protectbase
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/protectbase.conf
%{_datadir}/yum-plugins/protectbase.*

%files -n yum-plugin-versionlock
%defattr(-, qsys, *none)
%doc plugins/versionlock/README COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/versionlock.conf
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/versionlock.list
%{_datadir}/yum-plugins/versionlock.*
%{_mandir}/man1/yum-versionlock.1*
%{_mandir}/man5/yum-versionlock.conf.5*

%files -n yum-plugin-tsflags
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/tsflags.conf
%{_datadir}/yum-plugins/tsflags.*

%files -n yum-plugin-downloadonly
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/downloadonly.conf
%{_datadir}/yum-plugins/downloadonly.*

%files -n yum-plugin-priorities
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/priorities.conf
%{_datadir}/yum-plugins/priorities.*

# %files -n yum-plugin-refresh-updatesd
# %defattr(-, qsys, *none)
# %doc COPYING
# %config(noreplace) %{_sysconfdir}/yum/pluginconf.d/refresh-updatesd.conf
# %{_datadir}/yum-plugins/refresh-updatesd.*

%files -n yum-plugin-merge-conf
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/merge-conf.conf
%{_datadir}/yum-plugins/merge-conf.*

%files -n yum-plugin-security
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/security.conf
%{_datadir}/yum-plugins/security.*
%{_mandir}/man8/yum-security.8*

%files -n yum-plugin-upgrade-helper
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/upgrade-helper.conf
%{_datadir}/yum-plugins/upgrade-helper.*

# %files -n yum-plugin-aliases
# %defattr(-, qsys, *none)
# %doc COPYING
# %config(noreplace) %{_sysconfdir}/yum/pluginconf.d/aliases.conf
# %config(noreplace) %{_sysconfdir}/yum/aliases.conf
# %{_datadir}/yum-plugins/aliases.*
# %{_mandir}/man1/yum-aliases.1.*

%files -n yum-plugin-list-data
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/list-data.conf
%{_datadir}/yum-plugins/list-data.*
%{_mandir}/man1/yum-list-data.1*

%files -n yum-plugin-filter-data
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/filter-data.conf
%{_datadir}/yum-plugins/filter-data.*
%{_mandir}/man1/yum-filter-data.1*

%files -n yum-plugin-tmprepo
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/tmprepo.conf
%{_datadir}/yum-plugins/tmprepo.*

%files -n yum-plugin-verify
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/verify.conf
%{_datadir}/yum-plugins/verify.*
%{_mandir}/man1/yum-verify.1*

%files -n yum-plugin-keys
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/keys.conf
%{_datadir}/yum-plugins/keys.*

# %files -n yum-NetworkManager-dispatcher
# %defattr(-, qsys, *none)
# %doc COPYING
# /etc/NetworkManager/dispatcher.d/*

%files -n yum-plugin-remove-with-leaves
%defattr(-, qsys, *none)
%doc COPYING
%{_datadir}/yum-plugins/remove-with-leaves.*
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/remove-with-leaves.conf

%files -n yum-plugin-post-transaction-actions
%defattr(-, qsys, *none)
%doc COPYING
%{_datadir}/yum-plugins/post-transaction-actions.*
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/post-transaction-actions.conf
%doc plugins/post-transaction-actions/sample.action
# Default *.action file dropping dir.
%dir %{_sysconfdir}/yum/post-actions

%files -n yum-plugin-rpm-warm-cache
%defattr(-, qsys, *none)
%doc COPYING
%{_datadir}/yum-plugins/rpm-warm-cache.*
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/rpm-warm-cache.conf

# %files -n yum-plugin-auto-update-debug-info
# %defattr(-, qsys, *none)
# %doc COPYING
# %{_datadir}/yum-plugins/auto-update-debuginfo.*
# %config(noreplace) %{_sysconfdir}/yum/pluginconf.d/auto-update-debuginfo.conf

%files -n yum-plugin-show-leaves
%defattr(-, qsys, *none)
%doc COPYING
%{_datadir}/yum-plugins/show-leaves.*
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/show-leaves.conf

%files -n yum-plugin-local
%defattr(-, qsys, *none)
%doc COPYING
%ghost %{_sysconfdir}/yum.repos.d/_local.repo
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/local.conf
%{_datadir}/yum-plugins/local.*

# %files -n yum-plugin-fs-snapshot
# %defattr(-, qsys, *none)
# %doc COPYING
# %config(noreplace) %{_sysconfdir}/yum/pluginconf.d/fs-snapshot.conf
# %{_datadir}/yum-plugins/fs-snapshot.*
# %{_mandir}/man1/yum-fs-snapshot.1.*
# %{_mandir}/man5/yum-fs-snapshot.conf.5.*

%files -n yum-plugin-ps
%defattr(-, qsys, *none)
%doc COPYING
%config(noreplace) %{_sysconfdir}/yum/pluginconf.d/ps.conf
%{_datadir}/yum-plugins/ps.*

# %files -n yum-plugin-puppetverify
# %defattr(-, qsys, *none)
# %doc COPYING
# %config(noreplace) %{_sysconfdir}/yum/pluginconf.d/puppetverify.conf
# %{_datadir}/yum-plugins/puppetverify.*


%changelog
* Tue Dec 21 2021 Mark Irish <mirish@ibm.com> - 1.1.31
- Move .../sbin binaries to .../bin
- Create symlinks from old .../sbin binaries to their location in .../bin

* Tue May 26 2020 Naveen Ram <naveen.ram@ibm.com>
- Enable dateutils package for changelog plugin

* Mon Apr 08 2019 Kevin Adler <kadler@us.ibm.com>
- Actually apply *ALLOBJ patch...

* Mon Dec 31 2018 Kevin Adler <kadler@us.ibm.com>
- Check *ALLOBJ instead of uid 0 for permissions

* Mon Dec 31 2018 Jesse R. Gorzinski <jgorzins@us.ibm.com>
- Require Python2-iniparse

* Mon Dec 31 2018 Kevin Adler <kadler@us.ibm.com>
- Use correct python macro to fix build
- Use SPDX license

* Fri Aug 31 2018 Jesse R. Gorzinski <jgorzins@us.ibm.com>
- Fix /QOpenSys/etc path to /QOpenSys/etc/yum

* Wed Jul 18 2018 Kevin Adler <kadler@us.ibm.com>
- Add yum-utils
